#include <iostream>
#include <sys/wait.h>
#include <cmath>
#include <fstream>
#include <chrono>
#include <thread>
#include <vector>
#include <sys/resource.h>
bool paused(false);
bool exit_requested(false);
pid_t bcalc;
std::vector<pid_t> child_pids;
std::ifstream in("biblie.txt");

#define function(x) (x)/(tan(x)+exp(x))
int set_affinity(pid_t pid, int core_id) {
    cpu_set_t cpu_set;
    CPU_ZERO(&cpu_set);
    CPU_SET(core_id, &cpu_set);
//#ifdef DEBUG
    if (sched_setaffinity(pid, sizeof(cpu_set_t), &cpu_set) != 0) {
        std::cerr << "Error: Failed to set CPU affinity (errno: " << errno << ")." << std::endl;
        return -1;
    }
//#endif
    std::cout << "Affinity set to core " << core_id << " for process with PID: " << pid << std::endl;
    return 0;
}

char change_priority(pid_t pid, int priority) {
    if (setpriority(PRIO_PROCESS, pid, priority) == -1) {
        perror("Failed to change process priority");
        return -1;
    }
    std::cout << "Priority of process " << pid << " changed to " << priority << std::endl;
    return 0;
}

void pauseMenu(int signum) {
    std::cout<<std::endl;
    paused = true;
    char need=1;
    while (need){
    need=0;
        std::cout << "--- Menu ---"<<std::endl;
    if (kill(bcalc, 0) == 0)std::cout<<std::endl<<"==Триває процес заміни слів у файлі. Готово "<<static_cast<float>(in.tellg())*100/std::ifstream("biblie.txt", std::ios::binary | std::ios::ate).tellg()<<"%=="<<std::endl<<std::endl;
    std::cout <<"1. Exit"<<std::endl
              << "2. Resume"<<std::endl
              << "3. Show running processes"<<std::endl
              << "4. Change process priority"<<std::endl
              << "5. Kill process"<<std::endl
              << "6. Set affinity for process"<<std::endl
              << "Choice: ";
    unsigned int choice,choice2;
        if (need<2)
    std::cin >> choice;

    switch (choice) {
        case 1:
            exit_requested = true;
            kill(bcalc, SIGTERM);
            paused = false;
            break;
        case 2:
            paused = false;
            break;
        case 3:
            std::cout << "Running processes:"<<std::endl<<std::endl;
            if (kill(bcalc, 0) == 0)std::cout<<"0.\tPID: "<<bcalc<<" (find and replace process)"<<std::endl;
            for (unsigned short i=0; i<child_pids.size();i++) std::cout << i+1<<".\tPID: " << child_pids[i] << std::endl;
            std::cout<<std::endl;
            need=1;
            break;
        case 4:
            std::cout << "Enter PID (or 0 for bcalc): ";
            std::cin >> choice;
            if (choice == 0) choice = bcalc;
            std::cout << "Enter priority (-20 to 19): ";
            std::cin >> choice2;
            change_priority(choice, choice2);
            break;
        case 5:
            std::cout<< "Specify process to change priotiry (PID or num): ";
            std::cin>>choice;
            if (choice==0)choice=bcalc;
            if (choice<child_pids.size())choice=child_pids[choice-1];
            kill(choice,SIGKILL);
            if (child_pids.size())need=1;
            break;
        case 6:
            std::cout<< "Specify process to set affinity (PID or num): ";
            std::cin>>choice;
            if (choice==0)choice=bcalc;
            std::cout<< "Now enter affinity: ";
            std::cin>>choice2;
            if (choice<child_pids.size())choice=child_pids[choice-1];
            set_affinity(choice,choice2);
            if (child_pids.size())need=1;
            break;
        default:
            std::cout << "Invalid choice. Resuming...\n";
            paused = false;
            break;
        }
    }
}

int tabulateFunction(double start, double end, double precision) {
    std::ofstream file("out_" + std::to_string(start));
    for (unsigned int i = 0; i <= static_cast<unsigned int>((end - start) / precision); ++i) {
        double x = start + i * precision;
        file << "x = " << x << ", f(x) = " << function(x) << std::endl;
        while (paused)std::this_thread::sleep_for(std::chrono::milliseconds(100));
        if (exit_requested) {
            file.close();
            return -1;
        }
    }
    file.close();
    return 0;
}

void termb(int signum){kill(bcalc, SIGTERM);}

int main() {
    if (!in.is_open()){system("sh ../../makebig.sh");
        in.open("biblie.txt");}
    signal(SIGINT, pauseMenu);
    double start, end, acc;
    bcalc=fork();
    if (!bcalc){
        signal(SIGINT, SIG_DFL);
        sigset_t set;
        sigemptyset(&set);
        sigaddset(&set, SIGINT);
        sigprocmask(SIG_BLOCK, &set, NULL); // щоб нічого не наснилося
        std::chrono::steady_clock::time_point begin = std::chrono::steady_clock::now();
        std::ofstream out("so.txt");
        std::string line;
        unsigned int replaceCount = 0;
        while (std::getline(in, line)) {
            size_t pos = 0;
            while ((pos = line.find("and", pos)) != std::string::npos) {
                line.replace(pos, 3, "so");
                pos += 2;
                replaceCount++;
            }
            out << line << '\n';
        }
        out.close();in.close();
        std::cout<<"Процес заміни завершився! Замінено "<<replaceCount<<" входжень за "<<std::chrono::duration_cast<std::chrono::seconds>(
                                                                                  std::chrono::steady_clock::now() - begin).count()
                  << " секунд." << std::endl;;
            return 0;
    }
#ifdef DEBUG
    std::cout << "Введіть початкове значення x: ";
    std::cin >> start;
    std::cout << "Введіть кінцеве значення x: ";
    std::cin >> end;
    std::cout << "Введіть точність: ";
    std::cin >> acc;
#else
    start=0;
    end=100;
    acc=0.0001;
#endif

    for (unsigned short numProcesses = 1; numProcesses <= std::thread::hardware_concurrency() * 4; numProcesses++) {
        std::cout << "Trying " << numProcesses << " process";
        if (numProcesses - 1) std::cout << "es";
        std::cout << std::endl;

        std::chrono::steady_clock::time_point begin = std::chrono::steady_clock::now();
        double rangePerProcess = (end - start) / numProcesses;

        for (unsigned int i = 0; i < numProcesses; ++i) {
            pid_t pid = fork();
            if (pid == 0) {
                signal(SIGINT, SIG_DFL);
                sigset_t set;
                sigemptyset(&set);
                sigaddset(&set, SIGINT);
                sigprocmask(SIG_BLOCK, &set, NULL); // щоб нічого не наснилося
                double subStart = start + i * rangePerProcess;
                double subEnd = subStart + rangePerProcess;
#ifdef DEBUG
            std::cout << "Процес " << getpid() << " табулює на проміжку [" 
                      << subStart << ", " << subEnd << ']' << std::endl;
#endif
                return tabulateFunction(subStart, subEnd, acc);
            } else if (pid > 0)child_pids.push_back(pid);else {
                std::cerr << "Failed to fork." << std::endl;
                exit(EXIT_FAILURE);
            }
        }
        
        for (int i = 0; i < numProcesses; ++i) wait(&child_pids[i]);
        if (exit_requested)return -1;
        std::cout << "Took " << std::chrono::duration_cast<std::chrono::nanoseconds>(
                                    std::chrono::steady_clock::now() - begin).count()
                  << "ns" << std::endl;
        child_pids.clear();
    }
    if (kill(bcalc, 0) == 0) {
        std::cout<<"Очікування завершення процесу заміни... Натисніть Ctrl-С, щоб завершити зараз."<<std::endl;
        signal(SIGINT,termb);
        wait(&bcalc);
    }
    return 0;
}
